#include <iostream>

using namespace std;
int n, k;
int a[100010];
void podz1(){
    for(int i = 0; i < k; i++){
        int x = a[i];
        int ans = 0;
        for(int d = 1; d*d <= x; d++){
            if(x%d) continue;
            int d1 = d;
            int d2 = x/d1;
            if(d1==d2){
                ans ^= d1;
            }else{
                ans ^= d1;
                ans ^= d2;
            }
        }

        cout << ans << " ";
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> k;
    for(int i = 0; i < k; i++) cin >> a[i];
    if(n<100100) podz1();
    return 0;
}